//!	Arduino_DigitalInput.h


//--------------------------- inclusion guards ----------------------
#ifndef _Arduino_DigitalInput_h_
#define _Arduino_DigitalInput_h_


//--------------------------- include section -----------------------
#include "EOS_DigitalInput.h"
#include "Arduino.h"


//--------------------------- class definition ----------------------
//! this class represents an abstraction of an digital input used
//! with an Arduino board
//! \code
//! class CPin4 :
//!         public CArduino_DigitalInput<4>,
//!         public CArduino_DigitalOutput<4>
//! \endcode
template <int PIN>
class CArduino_DigitalInput :
    public CEOS_DigitalInput
{
//--------------------------- construction --------------------------
public:
    // constructor --------------------------------------------------
    //! \internal
    CONSTRUCTOR_EMPTY_NO_COPY_AND_ASSIGNMENT(CArduino_DigitalInput);


//--------------------------- public static access ------------------
public:
    // toDigitalInput -----------------------------------------------
    //! uses the Arduino function pinMode(pin,mode)
    inline virtual void toDigitalInput()
    {
        pinMode(PIN,INPUT);
    }

    // readDigital --------------------------------------------------
    //! uses the Arduino function digitalRead(pin)
    inline virtual bool_t readDigital()
    {
        return digitalRead(PIN);
    }

};


#endif
