//!	Arduino_DigitalOutput.h


//--------------------------- inclusion guards ----------------------
#ifndef _Arduino_DigitalOutput_h_
#define _Arduino_DigitalOutput_h_


//--------------------------- include section -----------------------
#include "EOS_DigitalOutput.h"
#include "Arduino.h"


//--------------------------- class definition ----------------------
//! this class represents an abstraction of an digital input used
//! with an Arduino board
//! \code
//! class CPin4 :
//!         public CArduino_DigitalInput<4>,
//!         public CArduino_DigitalOutput<4>
//! \endcode
template <int PIN>
class CArduino_DigitalOutput :
    public CEOS_DigitalOutput
{
//--------------------------- construction --------------------------
public:
    // constructor --------------------------------------------------
    //! \internal
    CONSTRUCTOR_EMPTY_NO_COPY_AND_ASSIGNMENT(CArduino_DigitalOutput);


//--------------------------- public access -------------------------
public:
    // operator = ---------------------------------------------------
    inline void operator = (bool_t bActive)
    {
        writeDigital(bActive);
    }

    // toDigitalOutput ----------------------------------------------
    //! uses the Arduino function pinMode(pin,mode)
    inline virtual void toDigitalOutput()
    {
        pinMode(PIN,OUTPUT);
    }

    // writeDigital -------------------------------------------------
    //! uses the Arduino function digitalWrite(pin,value)
    inline virtual void writeDigital(bool_t bActive)
    {
        digitalWrite(PIN,bActive);
    }

};


#endif
