//!	Pin10.h


//--------------------------- inclusion guards ----------------------
#ifndef _Pin10_h_
#define _Pin10_h_


//--------------------------- include section -----------------------
#include "Arduino_DigitalInput.h"
#include "Arduino_DigitalOutput.h"
#include "Arduino_AnalogOutput.h"


//--------------------------- class definition ----------------------
class CPin10 :
        public CArduino_DigitalInput<10>,
        public CArduino_DigitalOutput<10>,
        public CArduino_AnalogOutput<10,255>
{
//--------------------------- construction --------------------------
public:
    // constructor --------------------------------------------------
    //! this class has no member variables
    CONSTRUCTOR_EMPTY_NO_COPY_AND_ASSIGNMENT(CPin10);

//--------------------------- public access -------------------------
public:
    // operator = ---------------------------------------------------
    inline void operator = (const bool bActive)
    {
        writeDigital(bActive);
    }

    // operator = ---------------------------------------------------
    inline void operator = (const unsigned int nValue)
    {
        writeAnalog(nValue);
    }
};


static CPin10 Pin10;

#endif
