//!	Pin3.h


//--------------------------- inclusion guards ----------------------
#ifndef _Pin3_h_
#define _Pin3_h_


//--------------------------- include section -----------------------
#include "Arduino_DigitalInput.h"
#include "Arduino_DigitalOutput.h"
#include "Arduino_AnalogOutput.h"


//--------------------------- class definition ----------------------
class CPin3 :
        public CArduino_DigitalInput<3>,
        public CArduino_DigitalOutput<3>,
        public CArduino_AnalogOutput<3,255>
{
//--------------------------- construction --------------------------
public:
    // constructor --------------------------------------------------
    //! this class has no member variables
    CONSTRUCTOR_EMPTY_NO_COPY_AND_ASSIGNMENT(CPin3);

//--------------------------- public access -------------------------
public:
    // operator = ---------------------------------------------------
    inline void operator = (const bool bActive)
    {
        writeDigital(bActive);
    }

    // operator = ---------------------------------------------------
    inline void operator = (const unsigned int nValue)
    {
        writeAnalog(nValue);
    }

    // setPWMFrequency -----------------------------------------------
     unsigned int setPWMFrequency(unsigned int nFrequencyLow,
                            unsigned int nFrequencyHigh)
     {
         // Dividors is 1,8,32,64,128,256,1024
         const unsigned int nDividorArray[] = {1,8,32,64,128,256,1024};
         const BYTE btModeArray[] = {1,2,3,4,5,6,7};
         for (uint8 i = 0; i < sizeof(nDividorArray)/sizeof(nDividorArray[0]); i++)
         {
             unsigned int nFrequency = 31250/nDividorArray[i];
             if ((nFrequencyLow <= nFrequency) && (nFrequency <= nFrequencyHigh))
             {
                 // This frequency fits
                 // 0b1111 1000 = 0xF8
                 TCCR2B = (TCCR2B & 0xF8) | btModeArray[i];
                 return nFrequency;
             }
         }
         // Invalid frequency
         return 0;
     }
};


static CPin3 Pin3;

#endif
