//!	EOS_Statemachine.h


//--------------------------- inclusion guards ----------------------
#ifndef _EOS_Statemachine_h_
#define _EOS_Statemachine_h_


//--------------------------- include section -----------------------
#include "EOS_Timer.h"
#include "EOS_EventHandler.h"
#include "EOS_List.h"

#include "EOS_State.h"

//--------------------------- class definition ----------------------
template <class T_OBJECT>
class CEOS_Statemachine
{
//--------------------------- family --------------------------------
friend class CEOS_State<T_OBJECT>;

//--------------------------- construction --------------------------
public:
    // Constructor --------------------------------------------------
    inline CEOS_Statemachine(T_OBJECT* pObject) :
        m_pObject(pObject)
    {
        // Nothing to do
    }

    // Destructor ---------------------------------------------------
    inline ~CEOS_Statemachine()
    {
        // Nothing to do
    }

    // lock copy and assignement ------------------------------------
private:
    CEOS_Statemachine(const CEOS_Statemachine&);
    const CEOS_Statemachine& operator = (const CEOS_Statemachine&);


//--------------------------- public access -------------------------
public:
    // addEvent -----------------------------------------------------
    void addEvent(CEOS_Event* pEOS_Event)
    {
        typename CEOS_List<CEventHandler*>::TPosition pPosition = m_EventHandlerList.first();
        while (pPosition != NULL)
        {
            CEventHandler* pEventHandler = m_EventHandlerList.get(pPosition);
            if (pEventHandler->m_pEOS_Event == pEOS_Event)
            {
                // Found, nothing else to do
                return;
            }
            pPosition = m_EventHandlerList.next(pPosition);
        }
        // create a new entry
        CEventHandler* pEventHandler = (CEventHandler*)malloc(sizeof(CEventHandler));
        // set all member variables
        pEventHandler->m_pEOS_Statemachine = this;
        pEventHandler->setEvent(pEOS_Event);
        m_EventHandlerList.add(pEventHandler);
    }

    // setState -----------------------------------------------------
    void setState(CEOS_State<T_OBJECT>* pEOS_State)
    {
        m_pEOS_State = pEOS_State;
    }


//--------------------------- protected types ----------------------
protected:
    class CEventHandler : public CEOS_EventHandler<CEventHandler>
    {
    public:
        void setEvent(CEOS_Event* pEOS_Event)
        {
            m_pEOS_Event = pEOS_Event;
            CEOS_EventHandler<CEventHandler>::onEvent(pEOS_Event,&CEventHandler::onEvent);
        }

        void onEvent()
        {
            m_pEOS_Statemachine->onEvent(m_pEOS_Event);
        }

    public:
        CEOS_Statemachine<T_OBJECT>* m_pEOS_Statemachine;
        CEOS_Event* m_pEOS_Event;
    };


//--------------------------- public static access ------------------
public:


//--------------------------- public virtual access -----------------
public:

//--------------------------- protected access ----------------------
public:
    // onEvent ------------------------------------------------------
    void onEvent(CEOS_Event* pEOS_Event)
    {
        m_pEOS_State->onEvent(pEOS_Event);
    }


//--------------------------- protected data ------------------------
protected:



//--------------------------- protected data ------------------------
protected:
    // m_pObject ----------------------------------------------------
    T_OBJECT* m_pObject;

    // m_EventHandlerList -------------------------------------------
    CEOS_List<CEventHandler*> m_EventHandlerList;

    // m_IdleTaskInfoList -------------------------------------------
    CEOS_State<T_OBJECT>* m_pEOS_State;
};



#endif
